<?php

namespace TVn7\CoreBundle\Command;


use Symfony\Bundle\FrameworkBundle\Command\ContainerAwareCommand;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Doctrine\Common\Collections\ArrayCollection;

class SyncOVHAliasesCommand extends ContainerAwareCommand {


    protected function configure() {
        $this
            ->setName('TVn7:ovh:aliases:sync')
            ->setDescription('Sync OVH Aliases with TDB');
    }

    protected function execute(InputInterface $input, OutputInterface $output) {
        if($input->getOption('verbose')) $output->writeln("Begin sync");
        $em = $this->getContainer()->get('doctrine')->getManager();

        $aliases = new ArrayCollection($em->getRepository('TVn7DomainBundle:Alias')->findAll());

        $OVHAlias = $this->getContainer()->get('ovh.alias');

        foreach($aliases as $alias) {
            if($input->getOption('verbose')) $output->writeln("MYSQL : " . $alias->getAddr());
            $OVHAlias->sync($alias);
        }

        foreach($OVHAlias->getList() as $alias) {
            if($input->getOption('verbose')) $output->writeln("OVH : " . $alias->getLocal());
            $al = $aliases->filter(function($p) use ($alias) {
                return $alias->getLocal() === $p->getAddr();
            });
            if(count($al) == 0) {
                $OVHAlias->removeAlias($alias->getLocal());
            }
        }

        

        if($input->getOption('verbose')) $output->writeln("End sync");
    }
} 